﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Tasks;

namespace PhoneApp1
{
    public partial class ChooserTask : PhoneApplicationPage
    {
        private SavePhoneNumberTask nSavePhoneNum = new SavePhoneNumberTask();
        private PhoneNumberChooserTask nPhoneNumChooser = new PhoneNumberChooserTask();
        private SaveEmailAddressTask nSaveEmailAddress = new SaveEmailAddressTask();
        private EmailAddressChooserTask nEmailAddressChooser = new EmailAddressChooserTask();

        public ChooserTask()
        {
            InitializeComponent();

            nSavePhoneNum.Completed += new EventHandler<TaskEventArgs>(nSavePhoneNum_Completed);
            nPhoneNumChooser.Completed += new EventHandler<PhoneNumberResult>(nPhoneNumChooser_Completed);
            nSaveEmailAddress.Completed += new EventHandler<TaskEventArgs>(nSaveEmailAddress_Completed);
            nEmailAddressChooser.Completed += new EventHandler<EmailResult>(nEmailAddressChooser_Completed);
        }

        void nSavePhoneNum_Completed(object sender, TaskEventArgs e)
        {
            if (e.TaskResult == TaskResult.OK)
                MessageBox.Show("电话号码已经保存！");
            else
                MessageBox.Show("电话号码没有保存！");
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(PhoneNum.Text))
            {
                nSavePhoneNum.PhoneNumber = PhoneNum.Text;
                nSavePhoneNum.Show();
            }
        }

        void nPhoneNumChooser_Completed(object sender, PhoneNumberResult e)
        {
            if (e.TaskResult == TaskResult.OK)
            {
                PhoneNumChooser.Text = e.PhoneNumber;
            }
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            nPhoneNumChooser.Show();
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(PhoneNumChooser.Text))
            {
                PhoneCallTask nPhoneCall = new PhoneCallTask();
                nPhoneCall.PhoneNumber = PhoneNumChooser.Text;
                nPhoneCall.Show();
            }
        }

        private void Button_Click_3(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(PhoneNumChooser.Text))
            {
                SmsComposeTask nSendSms = new SmsComposeTask();
                nSendSms.To = PhoneNumChooser.Text;
                nSendSms.Body = "http://www.hugwp.com/thread-3624-1.html" + "卤面和亿动联合，重拳出击，夏日清凉来袭~ Lumia800带回家~";
                nSendSms.Show();
            }
        }

        void nSaveEmailAddress_Completed(object sender, TaskEventArgs e)
        {
            if (e.TaskResult == TaskResult.OK)
                MessageBox.Show("电子邮件地址已经保存！");
            else
                MessageBox.Show("电子邮件地址没有保存！");
        }

        private void Button_Click_4(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(EmailAddress.Text))
            {
                nSaveEmailAddress.Email = EmailAddress.Text;
                nSaveEmailAddress.Show();
            }
        }

        void nEmailAddressChooser_Completed(object sender, EmailResult e)
        {
            if (e.TaskResult == TaskResult.OK)
            {
                EmailAddressChooser.Text = e.Email;
            }
        }

        private void Button_Click_5(object sender, RoutedEventArgs e)
        {
            nEmailAddressChooser.Show();
        }

        private void Button_Click_6(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(EmailAddressChooser.Text))
            {
                EmailComposeTask nSendEmail = new EmailComposeTask();
                nSendEmail.To = EmailAddressChooser.Text;
                nSendEmail.Subject = "我们一起参加卤面比赛吧";
                nSendEmail.Body = "参加比赛一起赢取800哦。";
                nSendEmail.Show();
            }
        }
    }
}