﻿using Microsoft.Phone.Controls;
using System.Windows.Interactivity;
using System.Windows;

namespace PhoneApp1
{
    public class OrientationActive : TriggerAction<PhoneApplicationPage>
    {
        #region -- 自定义依赖属性 --
        public static readonly DependencyProperty LandscapeLeftStateNameProperty =
            DependencyProperty.Register("LandscapeLeftStateName", typeof(string), typeof(OrientationActive), new PropertyMetadata("LandscapeLeft"));
        public string LandscapeLeftStateName 
        {
            get { return (string)GetValue(LandscapeLeftStateNameProperty); }
            set { SetValue(LandscapeLeftStateNameProperty, value); }
        }

        public static readonly DependencyProperty LandscapeRightStateNameProperty =
            DependencyProperty.Register("LandscapeRightStateName", typeof(string), typeof(OrientationActive), new PropertyMetadata("LandscapeRight"));
        public string LandscapeRightStateName
        {
            get { return (string)GetValue(LandscapeRightStateNameProperty); }
            set { SetValue(LandscapeRightStateNameProperty, value); }
        }

        public static readonly DependencyProperty PortraitRightStateNameProperty =
            DependencyProperty.Register("PortraitRightStateName", typeof(string), typeof(OrientationActive), new PropertyMetadata("Portrait"));
        public string PortraitRightStateName
        {
            get { return (string)GetValue(PortraitRightStateNameProperty); }
            set { SetValue(PortraitRightStateNameProperty, value); }
        }
        #endregion

        protected override void Invoke(object parameter)
        {
            var nCtrl = this.AssociatedObject;
            var NewOrientation = (parameter as OrientationChangedEventArgs).Orientation;

            switch (NewOrientation)
            {
                case PageOrientation.Portrait:
                case PageOrientation.PortraitDown:
                case PageOrientation.PortraitUp:
                    VisualStateManager.GoToState(nCtrl, "Portrait", true);
                    break;
                case PageOrientation.LandscapeLeft:
                    VisualStateManager.GoToState(nCtrl, "LandscapeLeft", true);
                    break;
                case PageOrientation.LandscapeRight:
                    VisualStateManager.GoToState(nCtrl, "LandscapeRight", true);
                    break;
                case PageOrientation.Landscape:
                    break;
            }
        }
    }
}
