﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Tasks;
using System.Windows.Media.Imaging;

namespace PhoneApp1
{
    public partial class RingLoadingPage : PhoneApplicationPage
    {
        private CameraCaptureTask nCamera = new CameraCaptureTask();
        private PhotoChooserTask nPhoto = new PhotoChooserTask();

        public RingLoadingPage()
        {
            InitializeComponent();
            nCamera.Completed += new EventHandler<PhotoResult>(Camera_Completed);
            nPhoto.Completed += new EventHandler<PhotoResult>(nPhoto_Completed);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            LoadingStoryboard.Begin();
        }

        private void LoadingStoryboard_Completed(object sender, EventArgs e)
        {
            arc.EndAngle = 0;
            nCamera.Show();
        }

        private void Grid_Background(object sender, PhotoResult e)
        {
            if (e.TaskResult == TaskResult.OK)
            {
                if (e.ChosenPhoto != null && e.OriginalFileName.Length > 0)
                {
                    BitmapImage bitMap = new BitmapImage();
                    bitMap.SetSource(e.ChosenPhoto);

                    ImageBrush imageBrush = new ImageBrush();
                    imageBrush.ImageSource = bitMap;

                    ContentPanel.Background = imageBrush;
                }
            }
        }

        void Camera_Completed(object sender, PhotoResult e)
        {
            Grid_Background(sender, e);

            if (e.TaskResult == TaskResult.OK)
            {
                if (e.ChosenPhoto != null)
                {
                    BitmapImage bitMapS = new BitmapImage();
                    bitMapS.SetSource(e.ChosenPhoto);
                    this.ImageSource.Source = bitMapS;

                    BitmapImage bitMapD = new BitmapImage();
                    bitMapD.SetSource(e.ChosenPhoto);
                    WriteableBitmap writeBitmap = new WriteableBitmap(bitMapD);
                    GenerateMirrorImage(writeBitmap);
                }
            }
        }

        private void GenerateMirrorImage(WriteableBitmap nWriteableBitmap)
        {
            nWriteableBitmap.Invalidate();

            int pixelPosition = 0;//起始位置
            int reversePosition = nWriteableBitmap.PixelWidth * nWriteableBitmap.PixelHeight;//结束位置
            int pixlValue;
            //取高度的中心线为准，上下对换。
            for (int i = 0; i < nWriteableBitmap.PixelHeight / 2; i++)
            {   //取最后一行的第一个元素的下标
                reversePosition -= nWriteableBitmap.PixelWidth;
                for (int j = 0; j < nWriteableBitmap.PixelWidth; j++)
                {
                    pixlValue = nWriteableBitmap.Pixels[reversePosition];
                    nWriteableBitmap.Pixels[reversePosition] = nWriteableBitmap.Pixels[pixelPosition];
                    nWriteableBitmap.Pixels[pixelPosition] = pixlValue;

                    pixelPosition++;
                    reversePosition++;
                }
                //取倒数第二行的第一个元素的下标
                reversePosition -= nWriteableBitmap.PixelWidth;
            }
            this.ImageDes.Source = nWriteableBitmap;
        }

        void nPhoto_Completed(object sender, PhotoResult e)
        {
            if (e.TaskResult == TaskResult.OK)
            {
                if (e.ChosenPhoto != null)
                {
                    BitmapImage bitMapS = new BitmapImage();
                    bitMapS.SetSource(e.ChosenPhoto);
                    this.ImageChooser.Source = bitMapS;
                }
            }
        }

        private void Chooser_Click(object sender, EventArgs e)
        {
            this.nPhoto.PixelHeight = 100;
            this.nPhoto.PixelWidth = 100;
            this.nPhoto.ShowCamera = true;
            this.nPhoto.Show();
        }
    }
}