﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Linq;

namespace PhoneApp1
{
    public static class Utilities
    {
        public static KeyValuePair<string, T>[] EnumValues<T>(this Type enumerationType)
        {
            var enumList = new List<KeyValuePair<string, T>>();
            if (enumerationType.BaseType == typeof(Enum))
            {
                var fields = enumerationType.GetFields(BindingFlags.Public | BindingFlags.Static);
                foreach (var field in fields)
                {
                    var enumValue = field.GetValue(null);
                    if (((int)enumValue) > 0)
                    {
                        enumList.Add(new KeyValuePair<string, T>(enumValue.ToString(), (T)enumValue));
                    }
                }
            }
            return enumList.OrderBy(kvp => kvp.Key).ToArray();
        }
    }
}
